Bug 951637 - Stop linking to libgcrypt for gnutls
Summary: Stop linking to libgcrypt for gnutls
Keywords:
Status: CLOSED CURRENTRELEASE
Alias: None
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: libvirt
Version: 7.1
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Eric Blake
QA Contact: Virtualization Bugs
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-04-12 16:33 UTC by Daniel Berrangé
Modified: 2014-06-18 00:48 UTC (History)
6 users (show)

Fixed In Version: libvirt-1.1.1-3.el7
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-06-13 12:22:16 UTC


Attachments (Terms of Use)

Description Daniel Berrangé 2013-04-12 16:33:10 UTC
Description of problem:
Currently libvirt has code to initialize libgcrypt, as a pre-requisite to using gnutls. As a result libvirt also explicitly links to -lgcrypt.

In gnutls 3.x libgcrypt is replaced by libnettle. Libvirt's explicit initialization of libgcrypt is thus bogus and is causing libvirt to link to two crypto libraries (gcrypt + nettle).

Libvirt's libgcrypt init code should be made conditional so we don't use it when gnutls is linked to nettle.

Version-Release number of selected component (if applicable):
libvirt-1.0.4-1.el7

How reproducible:
Always

Steps to Reproduce:
1. $ ldd /lib64/libvirt.so.0 | grep gcrypt
2.
3.
  
Actual results:
	libgcrypt.so.11 => /lib64/libgcrypt.so.11 (0x0000003441800000)

Expected results:
Does not link to gcrypt

Additional info:

Comment 1 Eric Blake 2013-07-25 22:14:54 UTC
Upstream patch proposed:
https://www.redhat.com/archives/libvir-list/2013-July/msg01687.html

Comment 2 Eric Blake 2013-08-05 19:46:03 UTC
v3 of upstream patch; missed 1.1.1 so it will need a backport
https://www.redhat.com/archives/libvir-list/2013-July/msg01952.html

Comment 4 Huang Wenlong 2013-09-02 03:31:48 UTC
Reproduce this bug with 
libvirt.x86_64 0:1.1.1-2.el7 

# ldd /lib64/libvirt.so.0 | grep gcrypt 
	libgcrypt.so.11 => /lib64/libgcrypt.so.11 (0x00007fde15f48000)


Verify this bug with 
libvirt.x86_64 0:1.1.1-3.el7 


[root@localhost 111-3]# ldd /lib64/libvirt.so.0 | grep gcrypt 
[root@localhost 111-3]#

Comment 5 Ludek Smid 2014-06-13 12:22:16 UTC
This request was resolved in Red Hat Enterprise Linux 7.0.

Contact your manager or support representative in case you have further questions about the request.


Note You need to log in before you can comment on or make changes to this bug.